---
include:
  - template: Jobs/SAST.gitlab-ci.yml

image: framasoft/tests-hermes:latest
stages:
  - compile
  - lint
  - test

compile:
  stage: compile
  script:
    - python3 -m py_compile hermes.py

pep8:
  stage: lint
  script:
    - python3 /usr/lib/python3/dist-packages/pycodestyle.py hermes.py
pylint:
  stage: lint
  script:
    - 'pylint
      --rcfile .pylintrc
      hermes.py'
pylint-codeclimate:
  stage: lint
  script:
    - 'pylint
      --load-plugins=pylint_gitlab
      --output-format=gitlab-codeclimate
      --rcfile .pylintrc
      hermes.py > codeclimate.json'
  artifacts:
    reports:
      codequality: codeclimate.json
  needs:
    - pylint
pylint-junit:
  stage: lint
  script:
    - 'pylint
      --load-plugins=pylint_junit
      --output-format=pylint_junit.JUnitReporter
      --rcfile .pylintrc
      hermes.py > junit.xml'
  artifacts:
    reports:
      junit: junit.xml
  needs:
    - pylint
mypy:
  stage: lint
  script:
    # Can’t disable the check only for hermes in Bullseye
    - sed -e "/mypy-hermes/d" -i .mypy.ini
    - 'mypy
      --ignore-missing-imports
      --junit-xml junit.xml
      hermes.py'
  artifacts:
    reports:
      junit: junit.xml
